#ifndef AGC_H
#define AGC_H

#define AGC_WORD void

struct agc {
	AGC_WORD **data;
	int size;
	int next;
	struct agc_list *types;
	struct agc_list *finalizers;
};

struct agc_type {
	int (*predicate) (AGC_WORD*);
	AGC_WORD *(*copy) (struct agc *, AGC_WORD*);
};

struct agc_finalizer {
	AGC_WORD *obj;
	int (*predicate) (AGC_WORD*);
	void (*finalize) (AGC_WORD*);
	void (*update) (struct agc_finalizer*);
};

struct agc_list {
	void *obj;
	struct agc_list *next;
};

struct agc *agc_init();
struct agc *agc_init_with_size();
void agc_fini(struct agc *agc);

AGC_WORD *agc_alloc(struct agc *agc, int num, AGC_WORD **root);

AGC_WORD *agc_copy_object(struct agc *agc, AGC_WORD *obj);
int agc_collect(struct agc *agc, AGC_WORD **root);

int agc_register_type(struct agc *agc, struct agc_type *type);
struct agc_type *agc_register_new_type(struct agc *agc,
	int (*predicate) (AGC_WORD*),
	AGC_WORD *(*copy) (struct agc*, AGC_WORD*));

int agc_add_finalizer(struct agc *agc, struct agc_finalizer *finalizer);
struct agc_finalizer *agc_add_new_finalizer(struct agc *agc, AGC_WORD *obj,
	int (*prediacte) (AGC_WORD*), void (*finalize) (AGC_WORD*),
	void (*update) (struct agc_finalizer*));

#endif /* ndef AGC_H */
